﻿globalvar readCnt=0
globalvar writeCnt=0

-- Queue of lock requests
val m = Buffer()
-- Count of active readers/writers
val c = Counter()

{-- Process requests in sequence --}
def process() = 
  def grant(x) = 
  	-- Grant read request
    x >(false,s)>    
     c.inc() >> s.release()
    |
    -- Grant write request 
    x >(true,s)>
     c.onZero() >> c.inc() >> s.release() >> c.onZero()
    -- Goal expression of process()
m.get() >r> grant(r) >> process()
  
{-- Acquire the lock: argument is "true" if writing --}
def acquire(write) =
  val s = Semaphore(0)
  m.put((write, s)) >> s.acquire()
  
{-- Release the lock --}
def release() = c.dec()

{-- These definitions are for testing only --}
def reader(start) = Rtimer(start) >>
  acquire(false) >> $GUpdate({readCnt=readCnt+1}) >>
  Rtimer(1000) >> $GUpdate({readCnt=readCnt-1}) >>
  release() >> stop
def writer(start) = Rtimer(start) >>
  acquire(true) >> $GUpdate({writeCnt=writeCnt+1}) >>
  Rtimer(1000) >> $GUpdate({writeCnt=writeCnt-1}) >>
  release() >> stop
  
let(
    process()
    | reader(10)
    | writer(20)
    | reader(30)
    | reader(40)
    -- halt after the last reader finishes
	| Rtimer(50) >> acquire(true)
)

#define mutexViolation (readCnt>0 && writeCnt>0 || writeCnt >1)

--Property (3.1)
#assert System reaches mutexViolation;


